#{extends 'borderNG.html' /}

<ol class="breadcrumb">
    <li><a href="@{lelang.PaketCtr.index()}">&{'lelangpaket.daftar_paket'} </a>
    <li><a href="@{lelang.PaketCtr.edit(paket.pkt_id)}">&{'lelangpaket.edit_paket'} </a>
    <li class="active">&{'lelangpaket.ubah_konsolidasi'}</li>
</ol>

<div class="content">
    <table class="table table-sm table-bordered">
        <tr>
            <th class="bg-warning" width="200">&{'lelangpaket.kode_paket'}</th>
            <td>${paket?.pkt_id}</td>
        </tr>
        <tr>
            <th class="bg-warning" width="200">&{'lelangpaket.nama_paket'}</th>
            <td>${paket?.pkt_nama}</td>
        </tr>
        <tr>
            <th class="bg-warning" width="200">&{'lelangpaket.daftar_paket_terpilih'}</th>
            <td>
                <table class="table table-sm">
                    <tr>
                        <th>&{'lelangpaket.kode'}</th>
                        <th>&{'lelangpaket.nama'}</th>
                    </tr>
                    #{list konsolidasiList, as:'kl'}
                        <tr>
                            <td>${kl?.pkt_id}</td>
                            <td>${kl?.pkt_nama}</td>
                        </tr>
                    #{/list}
                </table>
            </td>
        </tr>
    </table>

    <div class="panel panel-default">
        <div class="panel-heading">&{'lelangpaket.daftar_paket'}</div>
    #{form @controllers.lelang.PaketCtr.ubahDaftarPaketSubmit(paket?.pkt_id), method:'POST', id:'form-ubah-paket'}
        #{list konsolidasiList, as:'kl'}
            <input name="pkt_old_ids" type="hidden" value="${kl?.pkt_id}">
        #{/list}
        <table class="table table-sm" id="tblPaket">
            <thead>
            <tr>
                <th class="text-center" width="10"><input type="checkbox" name="checkall" class="checkall"/></th>
                <th>&{'lelangpaket.kode'}</th>
                <th>&{'lelangpaket.nama'}</th>
                <th>&{'lelangpaket.tgl_buat'}</th>
            </tr>
            </thead>
        </table>
        <div class="card-footer">
            #{saveButton confirm: 'Apakah Anda yakin akan mengubah daftar Paket Konsolidasi?' /}
            #{backButton title:'Kembali', action:@lelang.PaketCtr.edit(paket?.pkt_id) /}
        </div>
    #{/form}
    </div>
</div>
#{set 'css_custom' }
<link href="https://cdnjs.cloudflare.com/ajax/libs/datatables/1.10.20/css/dataTables.bootstrap4.min.css" rel="stylesheet" type="text/css">
#{/set}

#{set 'custom_script'}
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/datatables/1.10.20/js/jquery.dataTables.min.js"></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/datatables/1.10.20/js/dataTables.bootstrap4.min.js"></script>
<script type="text/javascript" src="#{assets '/js/datatables.config.js'/}"></script>
<script type="text/javascript">
    $(document).ready(function() {
        var selected = [];
        var table = $("#tblPaket").DataTable({
            order: [[ 0, "desc"]],
            ajax: "@{DataTableCtr.paketKonsolidasiList()}",
            columns: [
                {
                    orderable: false,
                    render: function(data, type, row) {
                        var pktId = row[0]
                        var pktNama = row [1]
                        var pktTglDibuat = row[2]
                        var pktIdKonsolidasi = row[3]
                        var pktIdMain = '${paket?.pkt_id}'

                        if(pktIdKonsolidasi == pktIdMain) {
                            selected.push(pktId)
                            row[0] = "<center><input type='checkbox' name='paketIds' class='checkbox paketids' value=' " + pktId + "' checked/></center>"
                        } else {
                            row[0] = "<center><input type='checkbox' name='paketIds' class='checkbox paketids' value=' " + pktId + "'/></center>"
                        }

                        row[1] = pktId
                        row[2] = pktNama
                        row[3] = pktTglDibuat

                        return row[0];
                    }
                }, null, null, null
            ],
            rowCallback: function (row, data) {
                // Set the checked state of the checkbox in the table
                var pktId = data[2];
                if ($.inArray(pktId, selected) !== -1) {
                    $('input.paketids', row).prop('checked', true);
                    $(row).addClass('selected');
                }
            }
        });

        // Handle click on checkbox
        $('#tblPaket').on('click', '.paketids', function (e) {
            var $row = $(this).closest('tr');
            // Get row data
            var data = table.row($row).data();
            // Get row ID
            var rowId = data[2];
            inputSelected(rowId, this.checked);

            if (this.checked) {
                $row.addClass('selected');
            } else {
                $row.removeClass('selected');
            }

            // Update state of "Select all" control
            updateDataTableSelectAllCtrl(table);
            // Prevent click event from propagating to parent
            e.stopPropagation();
        });

        function inputAll(isChecked) {
            table.rows().eq(0).each( function ( index ) {
                var row = table.row( index );
                var data = row.data();
                inputSelected(data[2], isChecked);
            });
        }

        function inputSelected(rowId, isChecked) {
            // Determine whether row ID is in the list of selected row IDs
            var index = $.inArray(rowId, selected);
            // If checkbox is checked and row ID is not in list of selected row IDs
            if (isChecked && index === -1) {
                selected.push(rowId);
            } else if (!isChecked && index !== -1) {
                selected.splice(index, 1);
            }
        }

        // Handle click on table cells with checkboxes
        $('#datatable').on('click', 'tbody td, thead th:first-child', function (e) {
            $(this).parent().find('.paketids').trigger('click');
        });

        // Handle click on "Select all" control
        $('thead input[name="checkall"]', table.table().container()).on('click', function (e) {
            if (this.checked) {
                $('.paketids:not(:checked)').trigger('click');
            } else {
                $('.paketids:checked').trigger('click');
            }
            inputAll(this.checked);
            // Prevent click event from propagating to parent
            e.stopPropagation();
        });

        // Handle table draw event
        table.on('draw', function () {
            // Update state of "Select all" control
            updateDataTableSelectAllCtrl(table);
        });

        // Handle form submission event
        $("#form-ubah-paket").on('submit', function (e) {
            var form = $(this);
            // Iterate over all selected checkboxes
            $.each(selected, function (index, rowId) {
                // Create a hidden element
                $(form).append($('<input type="hidden" name="pkt_ids" value="' + rowId + '"/>'));
            });
        });

        $('.checkall').on('click', function () {
            var rows = table.rows({'search': 'applied'}).nodes();
            $('.paketids', rows).prop('checked', this.checked);
        });

        function updateDataTableSelectAllCtrl(table) {
            var $table = table.table().node();
            var $chkbox_all = $('tbody .paketids', $table);
            var $chkbox_checked = $('tbody .paketids:checked', $table);
            var chkbox_select_all = $('thead input[name="checkall"]', $table).get(0);

            // If none of the checkboxes are checked
            if ($chkbox_checked.length === 0) {
                chkbox_select_all.checked = false;
                if ('indeterminate' in chkbox_select_all) {
                    chkbox_select_all.indeterminate = false;
                }

                // If all of the checkboxes are checked
            } else if ($chkbox_checked.length === $chkbox_all.length) {
                chkbox_select_all.checked = true;
                if ('indeterminate' in chkbox_select_all) {
                    chkbox_select_all.indeterminate = false;
                }

                // If some of the checkboxes are checked
            } else {
                chkbox_select_all.checked = true;
                if ('indeterminate' in chkbox_select_all) {
                    chkbox_select_all.indeterminate = true;
                }
            }
        }
    });

</script>
#{/set}